<!-- Copyright (C) 2017-2020 Linagora

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. -->

<app-removable
  [isHoverVisible]="isDeleted"
  [message]="'This component has been removed'"
>
  <div fxFlexFill fxLayout="column" class="wrapper-content">
    <div
      *ngIf="component"
      fxLayout="column"
      fxLayoutGap="20px"
      class="content"
    >
      <mat-card fxFlex class="card-component-lifecycle">
        <mat-card-title class="light-bold title-about">About {{ component.name }}</mat-card-title>

        <mat-card-content class="margin-top-x1">
          <span fxLayout="row" class="mat-body-2 margin-bottom-x0">State</span>

          <div fxLayout="column" fxLayout.gt-sm="row" fxLayoutAlign="center start" fxLayoutAlign.gt-sm="start center" fxLayoutGap="20px">
            <div fxFlex="100" fxFlex.gt-sm="none" fxLayout="row" fxLayoutAlign="start center" class="component-state">
              <span>{{ component.state }}</span>
              <app-led [color]="getLedColorFromState(component.state)" class="margin-left-x1"></app-led>
            </div>

            <div *ngIf="component.state" fxFlex fxLayoutGap="10px" class="list-actions-name">
              <span 
                *ngFor="let possibleState of getPossibleStateActions(component.state); trackBy:trackByComponentState"
                fxFlexFill
                class="btn-state-{{ possibleState.actionName.toLowerCase() }}"
              >
                <button
                  mat-stroked-button
                  type="button"
                  color="primary"
                  [disabled]="component.isUpdating || ((possibleState.actionName === 'Unload' || possibleState.actionName === 'Uninstall') && component.serviceUnits.length > 0)"
                  (click)="changeState(possibleState.newStateAfterAction, component.id)"
                  class="btn-change-comp-state text-upper"
                >
                  <mat-icon *ngIf="possibleState.actionName === 'Install'">build</mat-icon>
                  <mat-icon *ngIf="possibleState.actionName === 'Stop'">stop</mat-icon>
                  <mat-icon *ngIf="possibleState.actionName === 'Start'">play_arrow</mat-icon>
                  <mat-icon
                    *ngIf="possibleState.actionName === 'Unload' && component.serviceUnits.length > 0"
                    matTooltip="To unload a component, all service units of the component should be unloaded first"
                    matTooltipPosition="above"
                  >info</mat-icon>
                  <mat-icon *ngIf="possibleState.actionName === 'Unload' && component.serviceUnits.length === 0">remove_circle_outline</mat-icon>
                  <mat-icon
                    *ngIf="possibleState.actionName === 'Uninstall' && component.serviceUnits.length > 0"
                    matTooltip="To uninstall a component, all service units of the component should be unloaded first"
                    matTooltipPosition="above"
                  >info</mat-icon>
                  <mat-icon *ngIf="possibleState.actionName === 'Uninstall' && component.serviceUnits.length === 0">build</mat-icon>
                  <span class="action-name margin-left-x1">{{ possibleState.actionName }}</span>
                </button>
              </span>
            </div>
          </div>
        </mat-card-content>

        <app-message
          type="error"
          [msg]="component.updateError"
          [isFullWidth]="true"
          class="error-change-state margin-bottom-x1"
        ></app-message>

        <mat-card-content>
          <span fxLayout="row" class="mat-body-2 margin-bottom-x1">Parameters</span>

          <form formnovalidate [formGroup]="parametersForm">
            <div *ngIf="(component.state === 'Stopped' || component.state === 'Shutdown'); else showParameters">
              <app-message
                type="info"
                msg="No configurable parameter in this state."
                [isClosable]="false"
                class="info-no-parameter"
              ></app-message>
            </div>

            <ng-template #showParameters>
              <div fxLayout="column" class="component-parameters">
                <div
                  fxLayout="row wrap"
                  fxLayout.sm="column"
                  fxLayout.xs="column"
                  fxLayoutGap.gt-sm="24px"
                  fxLayoutGap="0"
                >
                  <div *ngFor="let param of parametersForm.controls | keys | orderBy" [title]="param">
                    <mat-form-field
                      appearance="outline"
                      floatLabel="always"
                      fxFlex="calc(25% - 24px)"
                      fxFlex.gt-sm="calc(33.3% - 24px)"
                      class="param-name-form-field ellipsis"
                    >
                      <mat-label>{{ param }}</mat-label>
                      <input matInput type="text" [title]="component.parameters[param]" [formControlName]="param">
                    </mat-form-field>
                  </div>
                </div>

                <div fxLayout="row" fxLayoutAlign="end center">
                  <button
                    type="button"
                    mat-raised-button
                    color="primary"
                    [disabled]="component.isUpdating || parametersForm.pristine"
                    (click)="setParameters(component.id)"
                    class="btn-set-parameters-form text-upper"
                  >Set</button>
                </div>
              </div>
            </ng-template>

          </form>

        </mat-card-content>
      </mat-card>

      <mat-card fxFlex class="card-related-elements">
        <mat-card-title class="light-bold title-related-elements">Related Elements</mat-card-title>

        <ng-container
          *ngIf="component.sharedLibraries.length > 0 || component.serviceUnits.length > 0; else noRelatedElements"
        >
          <mat-card-content>
            <div fxLayout="column" fxLayoutGap="20px">
              <div fxLayout="column"  fxLayout.gt-md="row" fxLayoutGap="20px">
                <div
                  fxFlex
                  fxFlex.gt-sm="none"
                  fxLayout="row"
                  fxLayoutAlign="start center"
                  class="margin-top-x1"
                >
                  <div fxFlex="0 0 140px" fxFlexFill>Shared libraries</div>

                  <ng-template #noSl>
                    <app-message
                      type="info"
                      msg="This component doesn't use any shared library."
                      fxFlex
                      fxFlexFill
                      [isClosable]="false"
                      class="info-no-sl"
                    ></app-message>
                  </ng-template>
                </div>

                <ng-container *ngIf="component.sharedLibraries.length > 0; else noSl">
                  <div fxLayout="column" class="shared-libraries">
                    <div
                      fxLayout="row wrap"
                      fxLayoutGap="10"
                    >
                      <span
                        *ngFor="let sl of component.sharedLibraries"
                        fxFlexFill
                        class="shared-library"
                      >
                        <a
                          color="primary"
                          mat-stroked-button
                          matTooltipPosition="above"
                          [matTooltip]="sl.name"
                          [routerLink]="['/workspaces', (workspaceId$ | async), 'petals', 'shared-libraries', sl.id]"
                          class="btn-sl ellipsis"
                        >
                          {{ sl.name }}
                        </a>
                      </span>
                    </div>
                  </div>
                </ng-container>

              </div>

              <div fxLayout="column"  fxLayout.gt-md="row" fxLayoutGap="20px">
                <div
                  fxFlex
                  fxFlex.gt-md="none"
                  fxLayout="row"
                  fxLayoutAlign="start center"
                  class="margin-top-x1"
                >
                  <div fxFlex="0 0 140px" fxFlexFill>Services units</div>

                  <ng-template #noSu>
                    <app-message
                      type="info"
                      msg="This component doesn't have any service unit."
                      fxFlex
                      fxFlexFill
                      [isClosable]="false"
                      class="info-no-su"
                    ></app-message>
                  </ng-template>
                </div>

                <ng-container *ngIf="component.serviceUnits.length > 0 else noSu">
                  <div fxLayout="column" class="service-units">
                    <div
                      fxLayout="column"
                      fxLayout.gt-md="row wrap"
                      fxLayoutGap="0"
                      fxLayoutGap.gt-md="24px"
                    >
                      <div *ngFor="let su of component.serviceUnits" class="service-unit">
                        <span
                          fxFlex="calc(25% - 24px)"
                          fxFlex.gt-md="calc(33.3% - 24px)"
                          fxLayout="row"
                          fxLayoutAlign="start center"
                        >
                          <a
                            color="primary"
                            mat-stroked-button
                            matTooltipPosition="above"
                            [matTooltip]="su.name"
                            [routerLink]="['/workspaces', (workspaceId$ | async), 'petals', 'service-units', su.id]"
                            class="btn-su"
                          >
                            <span fxFlex class="su-name ellipsis">{{ su.name }}</span>
                          </a>
                          <app-led
                            matTooltipPosition="above"
                            [color]="getLedColorFromState(su.serviceAssembly.state)"
                            [matTooltip]="su.serviceAssembly.state"
                            class="su-led"
                          ></app-led>
                          <a
                            mat-icon-button
                            matTooltipPosition="above"
                            [matTooltip]="su.serviceAssembly.name"
                            [routerLink]="['/workspaces', (workspaceId$ | async), 'petals', 'service-assemblies', su.serviceAssembly.id]"
                            class="btn-fab-sa"
                          >
                            <mat-icon svgIcon="sa" color="primary" class="icon-x3"></mat-icon>
                          </a>
                        </span>
                      </div>
                    </div>
                  </div>
                </ng-container>
              </div>
            </div>
          </mat-card-content>
        </ng-container>

        <ng-template #noRelatedElements>
          <app-message
            type="info"
            msg="There are no related elements on this component."
            [isClosable]="false"
            class="info-no-related-elements"
          ></app-message>
        </ng-template>
      </mat-card>
      
      <app-su-deployment [component]="component"></app-su-deployment>
    </div>
  </div>
</app-removable>
